﻿// Fill out your copyright notice in the Description page of Project Settings.


#include "Telemetry.h"
#include "Misc/Guid.h"

void ATelemetry::SendEvent(FString EventKey, FString EventData)
{
	const FString EventID = FGuid::NewGuid().ToString();
	const FString EventTime = FDateTime::Now().ToString();
	const auto Request = FHttpModule::Get().CreateRequest();
	Request->SetURL(TelemetryURLEvents);
	Request->SetVerb("POST");
	Request->SetHeader("Content-Type", "application/json");
	Request->SetHeader("Accept", "application/json");
	Request->SetContentAsString( "{\"SessionID\":\"" + SessionID + "\",\"PlayerGUID\":\"" + PlayerGUID + "\",\"EventID\":\"" + EventID + "\",\"Timestamp\":\"" + EventTime + "\",\"EventKey\":\"" + EventKey + "\",\"EventData\":\"" + EventData + "\"}" );
	Request->OnProcessRequestComplete().BindLambda([](FHttpRequestPtr request, FHttpResponsePtr response, bool success)
	{
		GLog->Log("Telemetry Event Response: " + response->GetContentAsString());
	});
	Request->ProcessRequest();
}

void ATelemetry::BeginPlay()
{
	Super::BeginPlay();
	SessionID = FGuid::NewGuid().ToString().Left(5).ToUpper();
}
