﻿// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameState.h"
#include "Http.h"
#include "Telemetry.generated.h"

/**
 * 
 */
UCLASS()
class ENDLESSVENDETTA_API ATelemetry : public AGameState
{
	GENERATED_BODY()

public:
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString TelemetryURLEvents = "https://ev.api.philipwhite.dev/api/event";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString TelemetryURLUsers = "https://ev.api.philipwhite.dev/api/user";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString SessionID = "AAAAA";
	UPROPERTY(EditDefaultsOnly, BlueprintReadOnly, Category = "Telemetry")
	FString PlayerGUID = "aaaaaaaa-bbbb-cccc-dddd-eeeeeeeeeeee";
	
	UFUNCTION(BlueprintCallable, Category = "Telemetry")
	void SendEvent(FString EventKey, FString EventData);
	
protected:
	virtual void BeginPlay() override;
};
